import { _tuple } from "./symbols";
import { Validate } from "./validate";
import type { ReadonlyValit, Valitate } from "./valit";
export declare type RelationType = vality.Config extends {
    RelationType: infer R;
} ? R : number | null;
declare type DecD<D> = "in-layer-one" extends D ? "in" : D;
export declare type Parse<T, _D = "out"> = T extends infer U & {
    [_tuple]: true;
} ? {
    [K in keyof U]: Parse<U[K], DecD<_D>>;
} : T extends readonly [infer U] ? Parse<U, DecD<_D>>[] : T extends readonly (infer U)[] ? Parse<U, DecD<_D>> : T extends ReadonlyValit<infer U> ? "writeable" extends _D ? never : Parse<U, DecD<_D>> : T extends Valitate<infer U> ? Parse<U, DecD<_D>> : T extends Validate<infer U> ? U : T extends () => infer U ? "in-layer-one" extends _D ? Parse<U, "in"> : "in" extends _D ? RelationType : Parse<U, _D> : {
    -readonly [K in keyof T as Parse<T[K], _D> extends never ? never : K]: Parse<T[K], DecD<_D>>;
};
export declare type ParseOut<T> = Parse<T>;
export declare type ParseIn<T> = Parse<T, "in-layer-one">;
export {};
